<template>
	<view>

		<view class="mask" @tap="hideGoods" v-if="switchGoods"></view>
		<view class="car border-top u-flex u-row-between u-col-bottom u-relative">
			<view class="u-absolute goods bg-fff">
				<view
					class="u-p-t-32 color-666 border-bottom bg-fff u-absolute total u-p-r-28 u-p-b-32 u-p-l-28 u-flex u-row-between">
					<view>已添加{{goodsNumber}}件商品</view>
					<view class="color-666">
						<uni-icons color="#666" type="trash"></uni-icons>
						<text class="u-m-l-10" @tap="setModalShow('clear',true)">清空</text>
					</view>
				</view>
				<scroll-view scroll-y="true" class="tranistion" :style="{height:switchGoods?'50vh':0 }">
					<!-- 占位 -->
					<view class="u-p-t-32 color-666 border-bottom u-p-r-28 u-p-b-32 u-p-l-28 u-flex u-row-between"
						style="opacity: 0;">
						<view>已添加{{goodsNumber}}件商品</view>
						<view class="color-666">
							<uni-icons color="#666" type="trash"></uni-icons>
							<text class="u-m-l-10">清空</text>
						</view>
					</view>
					<!-- 占位 -->
					<view class="color-333 item border-top u-flex u-row-center u-row-between"
						v-for="(item,index) in data" :key="index">
						<view class="">
							<view class="u-line-1">{{item.name}}</view>
							<view class="u-m-t-10 u-font-24 color-666 u-line-1">{{item.specSnap||''}}</view>
						</view>
						<view class="u-flex">
							<view class="font-bold red u-m-r-32">￥{{formatPrice(item.salePrice*item.number) }}</view>
							<view class="u-flex" @tap="updateNumber(false,index,item)">
								<image src="/pagesCreateOrder/static/images/icon-reduce-black.svg" class="icon" mode="">
								</image>
							</view>
							<view class="u-m-l-30 u-m-r-30 color-333">
								{{item.number}}
							</view>
							<view class="u-flex" @tap="updateNumber(true,index,item)">
								<image src="/pagesCreateOrder/static/images/icon-add-black.svg" class="icon" mode="">
								</image>
							</view>

						</view>
					</view>
					<my-empty v-if="!data.length" text="暂未有添加商品"></my-empty>
				</scroll-view>

			</view>
			<view class="icon-car-box" @tap="toggleGoods">
				<image src="/pagesCreateOrder/static/images/icon-car.svg" class="icon-car" />
				<view class="dot">{{goodsNumber}}</view>
			</view>
			<view class="price font-bold u-flex">
				<view>￥</view>
				<view>{{allPrice}}</view>
			</view>
			<my-button shape="circle" height="80" width="220" @tap="toConfimOrder">
				<text class="u-font-32 font-bold">{{table.type=='add'?'确认加菜':'去下单'}} </text>
			</my-button>


		</view>
		<up-modal title="提示" content="是否清空全部已添加的商品?" :show="modal.clear" showCancelButton closeOnClickOverlay
			@confirm="confirmModelConfirm" @cancel="setModalShow('clear',false)" @close="setModalShow('clear',false)"
			width="300px"></up-modal>
	</view>
</template>

<script setup>
	import go from '@/commons/utils/go.js';
	import infoBox from '@/commons/utils/infoBox.js';
	import {
		formatPrice
	} from '@/commons/utils/format.js';

	import {
		computed,
		reactive,
		ref
	} from 'vue';
	const props = defineProps({
		data: {
			type: Array,
			default: () => {
				return []
			}
		},
		isCreateOrderToDetail: {
			type: Boolean,
			default: false
		},
		user: {
			type: Object,
			default: () => {
				return {
					id: ""
				}
			}
		},
		table: {
			type: Object,
			default: () => {
				return {
					tableId: ''
				}
			}
		},
		masterId: {
			type: [String, Number],
			default: ''
		}
	})
	const modal = reactive({
		key: '',
		clear: false
	})

	function confirmModelConfirm() {
		if (modal.key == 'clear') {
			clear()
		}
	}

	function setModalShow(key = 'show', show = true) {
		if (key == 'clear' && show && props.data.length <= 0) {
			return infoBox.showToast('购物车是空的！')
		}
		modal.key = key
		modal[key] = show
		console.log(modal);
	}



	const edmits = defineEmits(['clear', 'updateNumber'])

	// mask
	let switchGoods = ref(false)

	function hideGoods() {
		switchGoods.value = false
	}

	function showGoods() {
		switchGoods.value = true
	}

	function toggleGoods() {
		switchGoods.value = !switchGoods.value
	}

	function toConfimOrder() {
		console.log(props.user);
		if (props.data.length <= 0) {
			return infoBox.showToast('还没有选择商品')
		}
		const {
			tableId,
			name,
			maxCapacity,
			status,
			type
		} = props.table
		if (props.table.tableId == '') {
			go.to('PAGES_CONFIRM_ORDER', {
				masterId: props.masterId,
				isCreateOrderToDetail: props.isCreateOrderToDetail ? 1 : 0
			})
			return
		}
		go.to('PAGES_CONFIRM_ORDER', {
			masterId: props.masterId,
			type,
			tableId,
			name,
			maxCapacity,
			status,
			isCreateOrderToDetail: props.isCreateOrderToDetail ? 1 : 0
		})
	}

	const allPrice = computed(() => {
		return props.data.reduce((prve, cur) => {
			return prve + cur.salePrice * cur.number
		}, 0).toFixed(2)
	})

	const goodsNumber = computed(() => {
		let result = 0
		result = props.data.reduce((prve, cur) => {
			return prve + cur.number
		}, 0)
		return result >= 99 ? 99 : result
	})

	function updateNumber(isAdd, index, goods) {
		const step = isAdd ? 1 : -1
		const newval = goods.number + step
		const par = {
			num: newval,
			index: index,
			goods: goods
		}
		edmits('updateNumber', par)
	}

	function clear() {
		setModalShow('clear', false)
		edmits('clear')
		hideGoods()
	}

	import myButton from '@/components/my-components/my-button.vue'
</script>

<style lang="scss" scoped>
	$car-size: 96rpx;
	$car-top: -16rpx;

	@mixin fixedAll {
		position: fixed;
		left: 0;
		right: 0;
		top: 0;
		bottom: 0;
	}

	.total {
		left: 0;
		right: 0;
		top: 0;
		z-index: 1;
	}

	.icon {
		width: 40rpx;
		height: 40rpx
	}

	.mask {
		@include fixedAll;
		background: rgba(51, 51, 51, 0.5);
	}



	.goods {
		position: absolute;
		bottom: 100%;
		left: 0;
		right: 0;
		transition: all .2s ease-in-out;
		overflow: hidden;

		.item {
			padding: 32rpx 28rpx;
		}
	}

	.border-bottom {
		border-bottom: 1px solid #E5E5E5;
	}

	.border-top {
		border-top: 1px solid #E5E5E5;
	}

	.red {
		color: #EB4F4F;
	}

	.car {
		padding: 0 28rpx;
		position: relative;
		background-color: #fff;
		padding-top: 10rpx;
		padding-bottom: calc(40rpx + env(safe-area-inset-bottom));
		/* #ifdef H5 */
		padding-bottom: 68rpx;

		/* #endif */
		.icon-car-box {
			position: absolute;
			left: 28rpx;
			top: $car-top;
			display: flex;
			width: $car-size;
			height: $car-size;
			justify-content: center;
			align-items: center;
			z-index: 2;

			.dot {
				position: absolute;
				right: 0;
				top: 0;
				width: 28rpx;
				height: 28rpx;
				background: #EB4F4F;
				border-radius: 50%;
				display: flex;
				justify-content: center;
				align-items: center;
				font-size: 20rpx;
				font-weight: bold;
				color: #FFFFFF;
			}
		}

		.price {
			color: #EB4F4F;
			margin-left: calc(38rpx + $car-size);
			transform: translateY(calc($car-top / 2));
		}

		.icon-car {
			width: $car-size;
			height: $car-size;
		}
	}
</style>